package com.socialstalkr.model {
  import com.adobe.cairngorm.model.IModelLocator;
  import mx.collections.XMLListCollection;
  import mx.formatters.DateFormatter;

  [Bindable]
  public class SocialStalkrModelLocator implements IModelLocator {
    private static var _modelLocator:SocialStalkrModelLocator;
    public var userName:String;
    public var userPassword:String;
    public var twitterUser:XML;
    public var twitterUserTweets:XMLListCollection;
    public var twitterUserFriends:XMLListCollection;
    public var selectedFriend:XML;
    public var selectedFriendTweets:XMLListCollection;
    public var dateFormatter:DateFormatter;
    public var selectedTweet:XML;

    public function formatTweet(item:Object):String {
      var status:XML = XML(item);
      return status.text + " at " + dateFormatter.format(
        dateFromTwitterDate(status.created_at));
    }
  
    public static function dateFromTwitterDate(twDate:String):Date {
      return new Date(twDate.substr(0,10) +
          " " + twDate.substr(twDate.length - 4, twDate.length) +
          " " + twDate.substr(11, 8));
    }
  
    public function SocialStalkrModelLocator(
      enforcer:SingletonEnforcer) {
      dateFormatter = new DateFormatter();
      dateFormatter.formatString = "L:NN A on EEEE, MMM. D";
    }
    
    public static function get instance():
    SocialStalkrModelLocator {
      if (_modelLocator == null) {
        _modelLocator = new SocialStalkrModelLocator(
          new SingletonEnforcer());
      }
      return _modelLocator;
    }
  }
}

class SingletonEnforcer {}